Unit QS40R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS10_p;

procedure QS40R(var INT :Real; var A1 :Array of Real;
                var A2 :Array of Real; F :Func_F1A; EPS :Real;
                var IERR :Integer);

implementation

procedure QS40R(var INT :Real; var A1 :Array of Real;
                var A2 :Array of Real; F :Func_F1A; EPS :Real;
                var IERR :Integer);
var
I,K,L,N :Integer;
H,H1,S1,S11,S2,R1,R2 :Real;
R :Array [0..7] of Integer;
C :Array [0..1] of Real;
X :Array [0..1] of Real;
Z :Array [0..1] of Real;
D :Array [0..2] of Real;
B :Array [0..10] of Real;
T :Array [0..32] of Real;
const
EDMA2 :Real = 3.292723E-10;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
{   DATA  FORTRAN  }
R[0] := 0;
R[1] := -1;
R[2] := 0;
R[3] := 1;
R[4] := -1;
R[5] := 1;
R[6] := -1;
R[7] := 1;
B[0] := 0.658150;
B[1] := 0.549120;
B[2] := 0.894427;
B[3] := 0.316228;
B[4] := 1.061362;
B[5] := -0.234973;
B[6] := 0.173611;
B[7] := 3.999428;
B[8] := -6.298039;
B[9] := 0.124008;
B[10] := 3.174603;
D[0] := (A2[0]-A1[0])*(A2[1]-A1[1]);
D[2] := 1.0;
D[1] := EDMA2;
IERR := 0;
INT := 0;
L := 1;
H := 0.5;
K := 0;
C[0] := 0.75;
C[1] := 0.75;
goto _7;
_1:
H := H/2;
if ( H-D[1] ) < 0
 then goto _2
 else if ( H-D[1] ) > 0
       then goto _3
       else goto _3;
_2:
IERR := 65;
goto _4;
_3:
T[L-1] := K;
L := L+1;
K := 0;
H1 := H/2.0;
C[0] := C[0]+H1*R[3];
C[1] := C[1]+H1*R[7];
goto _7;
_4:
C[0] := C[0]+H*R[(K+1-1)+0];
C[1] := C[1]+H*R[(K+1-1)+4];
K := K+1;
if ( K-4 ) < 0
 then goto _7
 else if ( K-4 ) > 0
       then goto _7
       else goto _5;
_5:
if ( L-1 ) < 0
 then goto _6
 else if ( L-1 ) > 0
       then goto _6
       else goto _15;
_6:
L := L-1;
H1 := H/2.0;
C[0] := C[0]-H1*R[3];
C[1] := C[1]-H1*R[7];
H := 2.0*H;
K := Trunc( T[L-1] );
goto _4;
_7:
H1 := H/2.0;
S11 := 0;
S2 := 0;
R1 := 0;
R2 := 0;
for I:=1 to 3 do
 begin
  for N:=1 to 3 do
   begin
    if ( Abs(I-2)+Abs(N-2)-1 ) < 0
     then goto _9
     else if ( Abs(I-2)+Abs(N-2)-1 ) > 0
           then goto _9
           else goto _8;
_8:
    Z[0] := C[0]+(I-2)*B[0]*H1;
    Z[1] := C[1]+(N-2)*B[0]*H1;
    X[0] := (A2[0]-A1[0])*Z[0]+A1[0];
    X[1] := (A2[1]-A1[1])*Z[1]+A1[1];
    S11 := S11+F(X);
    Z[0] := C[0]+(I-2)*B[1]*H1;
    Z[1] := C[1]+(N-2)*B[1]*H1;
    X[0] := (A2[0]-A1[0])*Z[0]+A1[0];
    X[1] := (A2[1]-A1[1])*Z[1]+A1[1];
    S2 := S2+F(X);
_9:
   end;
_10:
 end;
I := 1;
while ( I<=3 ) do
 begin
  N := 1;
  while ( N<=3 ) do
   begin
    Z[0] := C[0]+(I-2)*B[2]*H1;
    Z[1] := C[1]+(N-2)*B[2]*H1;
    X[0] := (A2[0]-A1[0])*Z[0]+A1[0];
    X[1] := (A2[1]-A1[1])*Z[1]+A1[1];
    R1 := R1+F(X);
    Z[0] := C[0]+(I-2)*B[3]*H1;
    Z[1] := C[1]+(N-2)*B[3]*H1;
    X[0] := (A2[0]-A1[0])*Z[0]+A1[0];
    X[1] := (A2[1]-A1[1])*Z[1]+A1[1];
    R2 := R2+F(X);
_11:
    inc(N,2);
   end;
_12:
  inc(I,2);
 end;
S1 := B[4]*S11+B[5]*S2+B[6]*R1;
S2 := B[7]*S11+B[8]*S2+B[9]*R1+B[10]*R2;
S1 := D[0]*S1*H1*H1;
S2 := D[0]*S2*H1*H1;
if ( Abs(S1-S2)-EPS ) < 0
 then goto _13
 else if ( Abs(S1-S2)-EPS ) > 0
       then goto _14
       else goto _13;
_13:
INT := INT+S2;
goto _4;
_14:
goto _1;
_15:
if ( IERR  <> 0 ) 
 then UTQS10(IERR,5);
end;

end.
